//==SET SENSOR VALUE==//
const int IR_RANGE[5] = {300, 300, 300, 300, 300};               // 0 : Back_L,   1 : Back_R,   2 : Front_L,   3 : Front_M,   4 : Front_R
const int PSD_RANGE[6] = {350, 350, 350, 350, 350, 350};    // 0 : Back_L,   1 : Back_M,   2 : Back_R,   3 : Front_L,    4 : Front_M,   5 : Front_R

//===PIN SETUP===//
const int IN_L = 8;
const int IN_R = 7;
const int PWM_L = 6;
const int PWM_R = 5;
const int s0 = 4;
const int s1 = 3;
const int s2 = 2;
const int PSD_MUX = A0;
const int IR_SENSOR[5] = {A2,A3,A4,A5,A6};

//===Variable SETUP===//
int IR_ADC[5] = {0, };
int PSD_ADC[6] = {0, };
float Filltered_PSD_ADC[6] = {0, };
float sensitivity = 0.5;

//===FUNCTION===//
void GO(int SPEED_L, int SPEED_R, int DIR);
void STOP();
int readMux(int Ch);

void BottleSumo()
{
  //Main Code//
  if( IR_ADC[0] >= IR_RANGE[0] && IR_ADC[1] >= IR_RANGE[1] && IR_ADC[2] >= IR_RANGE[2] && IR_ADC[3] >= IR_RANGE[3] && IR_ADC[4] >= IR_RANGE[4] ) // In the field
  {
     if(Filltered_PSD_ADC[1] >= PSD_RANGE[1]) {
      GO(60, 60, 0);
    }
    else if (Filltered_PSD_ADC[0] >= PSD_RANGE[0]) {
      GO(50, 50, 1);
    }
    else if (Filltered_PSD_ADC[2] >= PSD_RANGE[2]) {
      GO(50, 50, 2);
    }
    else {
      GO(60, 60, 0);
    }

  }
  else if(IR_ADC[0] < IR_RANGE[0] || IR_ADC[1] < IR_RANGE[1]) // Must Go Straight
  {
    if(IR_ADC[0] < IR_RANGE[0] && IR_ADC[1] < IR_RANGE[1]) {
      GO(60, 60, 0);
      delay(500);
      GO(50, 50, 2);
      delay(200);
    }
    else if(IR_ADC[0] < IR_RANGE[0]) {
      GO(60, 60, 0);
      delay(500);
      GO(50, 50, 2);
      delay(200);
    }
    else if(IR_ADC[0] < IR_RANGE[0]) {
      GO(60, 60, 0);
      delay(500);
      GO(50, 50, 1);
      delay(200);
    }

  }
  else if( IR_ADC[2] < IR_RANGE[2] || IR_ADC[3] < IR_RANGE[3] || IR_ADC[4] < IR_RANGE[4] )//Must Go Back
  {
    if(IR_ADC[2] < IR_RANGE[2] && IR_ADC[3] >= IR_RANGE[3] && IR_ADC[4] >= IR_RANGE[4]) {
      GO(60, 60, 4);
      delay(500);
      GO(50, 50, 2);
      delay(500);
    }
    else if(IR_ADC[2] >= IR_RANGE[2] && IR_ADC[3] >= IR_RANGE[3] && IR_ADC[4] < IR_RANGE[4]) {
      GO(60, 60, 4);
      delay(500);
      GO(50, 50, 1);
      delay(500);
    }
    else {
      GO(60, 60, 4);
      delay(500);
      GO(50, 50, 2);
      delay(500);
    }

  }
}
void GO(int SPEED_L, int SPEED_R, int DIR)
{
  if(DIR == 0) {  //=== GO STRAIGHT
    digitalWrite(IN_L,HIGH);
    digitalWrite(IN_R,HIGH);
  }
  else if(DIR == 1) {  //=== TURN L
    digitalWrite(IN_L,LOW);
    digitalWrite(IN_R,HIGH);
  }
  else if(DIR == 2) {  //=== TURN R
    digitalWrite(IN_L,HIGH);
    digitalWrite(IN_R,LOW);
  }
  else if(DIR == 4) {  //=== BACK
    digitalWrite(IN_L,LOW);
    digitalWrite(IN_R,LOW);
  }
  analogWrite(PWM_L, SPEED_L);
  analogWrite(PWM_R, SPEED_R);
}

void  STOP()
{
   digitalWrite(IN_L,LOW);
   digitalWrite(IN_R,LOW);

  analogWrite(PWM_L, 0);
  analogWrite(PWM_R, 0);
}
//---------------------------------------------------------
int readMux(int Ch)
{
  int controlPin[] = {s0,s1,s2};
  int muxChannel[8][3] = {
  {0,0,0},
  {1,0,0},
  {0,1,0},
  {1,1,0},
  {0,0,1},
  {1,0,1},
  {0,1,1},
  {1,1,1}
  };
  for(int i = 0; i < 3; i++) {
    digitalWrite(controlPin[i], muxChannel[Ch][i]);
  }

  int val = analogRead(PSD_MUX);
  return val;
}
